ON_NurbsCage Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h>`

Inheritance diagram for ON_NurbsCage:

## Public Member Functions

| ON_NurbsCage ()
| ON_NurbsCage (int dim, bool is_rat, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
| ON_NurbsCage (const ON_BoundingBox &bbox, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
| ON_NurbsCage (const ON_3dPoint *box_corners, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
| ON_NurbsCage (const ON_BezierCage &src)
| ~ON_NurbsCage ()
| ON_NurbsCage (const ON_NurbsCage &src)
ON_NurbsCage & | operator= (const ON_NurbsCage &src)
ON_NurbsCage & | operator= (const ON_BezierCage &src)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &text_log) const
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | Read (ON_BinaryArchive &archive)
ON_BOOL32 | Write (ON_BinaryArchive &archive) const
ON::object_type | ObjectType () const
void | DestroyRuntimeCache (bool bDelete=true)
int | Dimension () const
ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &xform)
bool | IsDeformable () const
bool | MakeDeformable ()
bool | IsParallelogram (double tolerance) const
bool | Create (int dim, bool is_rat, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
bool | Create (const ON_BoundingBox &bbox, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
bool | Create (const ON_3dPoint *box_corners, int order0, int order1, int order2, int cv_count0, int cv_count1, int cv_count2)
void | Destroy ()
void | EmergencyDestroy ()
ON_Interval | Domain (int) const
bool | Reverse (int dir)
bool | Transpose (int dir0, int dir1)
bool | ClampEnd (int dir, int end)
bool | InsertKnot (int dir, double knot_value, int knot_multiplicity=1)
ON_BOOL32 | IncreaseDegree (int dir, int desired_degree)
ON_BOOL32 | ChangeDimension (int desired_dimension)
bool | Evaluate (double r, double s, double t, int der_count, int v_stride, double *v, int side=0, int *hint=0) const
ON_3dPoint | PointAt (double r, double s, double t) const
ON_NurbsSurface * | IsoSurface (int dir, double c, ON_NurbsSurface *srf=0) const
bool | Trim (int dir, const ON_Interval &domain)
bool | Extend (int dir, const ON_Interval &domain)
ON_3dPoint | PointAt (ON_3dPoint rst) const
bool | IsRational () const
int | CVSize () const
int | Order (int dir) const
int | CVCount (int) const
int | CVCount (void) const
int | KnotCount (int dir) const
int | Degree (int dir) const
int | SpanCount (int dir) const
bool | GetSpanVector (int dir, double *span_vector) const
double * | CV (int i, int j, int k) const
ON::point_style | CVStyle () const
double | Weight (int i, int j, int k) const
bool | SetWeight (int i, int j, int k, double w)
bool | SetCV (int i, int j, int k, ON::point_style, const double *)
bool | SetCV (int i, int j, int k, const ON_3dPoint &point)
bool | SetCV (int i, int j, int k, const ON_4dPoint &hpoint)
bool | GetCV (int i, int j, int k, ON::point_style, double *) const
bool | GetCV (int i, int j, int k, ON_3dPoint &) const
bool | GetCV (int i, int j, int k, ON_4dPoint &) const
bool | SetKnot (int dir, int knot_index, double knot_value)
double | Knot (int dir, int knot_index) const
bool | ZeroCVs ()
bool | MakeRational ()
bool | MakeNonRational ()
bool | IsClosed (int) const
bool | IsPeriodic (int) const
bool | IsSingular (int) const
double | GrevilleAbcissa (int dir, int gindex) const
bool | ReserveCVCapacity (int cv_capacity)
bool | ReserveKnotCapacity (int dir, int cv_capacity)
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

int | m_dim
bool | m_is_rat
int | m_order [3]
int | m_cv_count [3]
int | m_knot_capacity [3]
double * | m_knot [3]
int | m_cv_stride [3]
int | m_cv_capacity
double * | m_cv

## Detailed Description

Definition at line 1028 of file opennurbs_nurbssurface.h.

## Constructor & Destructor Documentation

## ON_NurbsCage() [1/6]

ON_NurbsCage::ON_NurbsCage | ( |  | ) |

## ON_NurbsCage() [2/6]

ON_NurbsCage::ON_NurbsCage | ( | int | dim,
|  | bool | is_rat,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## ON_NurbsCage() [3/6]

ON_NurbsCage::ON_NurbsCage | ( | const ON_BoundingBox & | bbox,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## ON_NurbsCage() [4/6]

ON_NurbsCage::ON_NurbsCage | ( | const ON_3dPoint * | box_corners,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## ON_NurbsCage() [5/6]

ON_NurbsCage::ON_NurbsCage | ( | const ON_BezierCage & | src | ) |

## ~ON_NurbsCage()

ON_NurbsCage::~ON_NurbsCage | ( |  | ) |

## ON_NurbsCage() [6/6]

ON_NurbsCage::ON_NurbsCage | ( | const ON_NurbsCage & | src | ) |

## Member Function Documentation

## ChangeDimension()

ON_BOOL32 ON_NurbsCage::ChangeDimension | ( | int | desired_dimension | ) |

## ClampEnd()

bool ON_NurbsCage::ClampEnd | ( | int | dir,
|  | int | end
| ) |  |

## Create() [1/3]

bool ON_NurbsCage::Create | ( | const ON_3dPoint * | box_corners,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## Create() [2/3]

bool ON_NurbsCage::Create | ( | const ON_BoundingBox & | bbox,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## Create() [3/3]

bool ON_NurbsCage::Create | ( | int | dim,
|  | bool | is_rat,
|  | int | order0,
|  | int | order1,
|  | int | order2,
|  | int | cv_count0,
|  | int | cv_count1,
|  | int | cv_count2
| ) |  |

## CV()

double* ON_NurbsCage::CV | ( | int | i,
|  | int | j,
|  | int | k
| ) |  | const

## CVCount() [1/2]

int ON_NurbsCage::CVCount | ( | int |  | ) | const

## CVCount() [2/2]

int ON_NurbsCage::CVCount | ( | void |  | ) | const

## CVSize()

int ON_NurbsCage::CVSize | ( |  | ) | const

## CVStyle()

ON::point_style ON_NurbsCage::CVStyle | ( |  | ) | const

## DataCRC()

ON__UINT32 ON_NurbsCage::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## Degree()

int ON_NurbsCage::Degree | ( | int | dir | ) | const

## Destroy()

void ON_NurbsCage::Destroy | ( |  | ) |

## DestroyRuntimeCache()

void ON_NurbsCage::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dimension()

int ON_NurbsCage::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Domain()

ON_Interval ON_NurbsCage::Domain | ( | int |  | ) | const

## Dump()

void ON_NurbsCage::Dump | ( | ON_TextLog & | text_log | ) | const

virtual

Reimplemented from ON_Object.

## EmergencyDestroy()

void ON_NurbsCage::EmergencyDestroy | ( |  | ) |

## Evaluate()

bool ON_NurbsCage::Evaluate | ( | double | r,
|  | double | s,
|  | double | t,
|  | int | der_count,
|  | int | v_stride,
|  | double * | v,
|  | int | side = `0`,
|  | int * | hint = `0`
| ) |  | const

## Extend()

bool ON_NurbsCage::Extend | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

## GetBBox()

ON_BOOL32 ON_NurbsCage::GetBBox | ( | double * | boxmin,
|  | double * | boxmax,
|  | int | bGrowBox = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetCV() [1/3]

bool ON_NurbsCage::GetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | ON::point_style | ,
|  | double * |
| ) |  | const

## GetCV() [2/3]

bool ON_NurbsCage::GetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | ON_3dPoint & |
| ) |  | const

## GetCV() [3/3]

bool ON_NurbsCage::GetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | ON_4dPoint & |
| ) |  | const

## GetSpanVector()

bool ON_NurbsCage::GetSpanVector | ( | int | dir,
|  | double * | span_vector
| ) |  | const

## GetTightBoundingBox()

bool ON_NurbsCage::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## GrevilleAbcissa()

double ON_NurbsCage::GrevilleAbcissa | ( | int | dir,
|  | int | gindex
| ) |  | const

## IncreaseDegree()

ON_BOOL32 ON_NurbsCage::IncreaseDegree | ( | int | dir,
|  | int | desired_degree
| ) |  |

## InsertKnot()

bool ON_NurbsCage::InsertKnot | ( | int | dir,
|  | double | knot_value,
|  | int | knot_multiplicity = `1`
| ) |  |

## IsClosed()

bool ON_NurbsCage::IsClosed | ( | int |  | ) | const

## IsDeformable()

bool ON_NurbsCage::IsDeformable | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## IsoSurface()

ON_NurbsSurface* ON_NurbsCage::IsoSurface | ( | int | dir,
|  | double | c,
|  | ON_NurbsSurface * | srf = `0`
| ) |  | const

## IsParallelogram()

bool ON_NurbsCage::IsParallelogram | ( | double | tolerance | ) | const

## IsPeriodic()

bool ON_NurbsCage::IsPeriodic | ( | int |  | ) | const

## IsRational()

bool ON_NurbsCage::IsRational | ( |  | ) | const

## IsSingular()

bool ON_NurbsCage::IsSingular | ( | int |  | ) | const

## IsValid()

ON_BOOL32 ON_NurbsCage::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Knot()

double ON_NurbsCage::Knot | ( | int | dir,
|  | int | knot_index
| ) |  | const

## KnotCount()

int ON_NurbsCage::KnotCount | ( | int | dir | ) | const

## MakeDeformable()

bool ON_NurbsCage::MakeDeformable | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## MakeNonRational()

bool ON_NurbsCage::MakeNonRational | ( |  | ) |

## MakeRational()

bool ON_NurbsCage::MakeRational | ( |  | ) |

## ObjectType()

ON::object_type ON_NurbsCage::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator=() [1/2]

ON_NurbsCage& ON_NurbsCage::operator= | ( | const ON_BezierCage & | src | ) |

## operator=() [2/2]

ON_NurbsCage& ON_NurbsCage::operator= | ( | const ON_NurbsCage & | src | ) |

## Order()

int ON_NurbsCage::Order | ( | int | dir | ) | const

## PointAt() [1/2]

ON_3dPoint ON_NurbsCage::PointAt | ( | double | r,
|  | double | s,
|  | double | t
| ) |  | const

## PointAt() [2/2]

ON_3dPoint ON_NurbsCage::PointAt | ( | ON_3dPoint | rst | ) | const

## Read()

ON_BOOL32 ON_NurbsCage::Read | ( | ON_BinaryArchive & | archive | ) |

virtual

Reimplemented from ON_Object.

## ReserveCVCapacity()

bool ON_NurbsCage::ReserveCVCapacity | ( | int | cv_capacity | ) |

## ReserveKnotCapacity()

bool ON_NurbsCage::ReserveKnotCapacity | ( | int | dir,
|  | int | cv_capacity
| ) |  |

## Reverse()

bool ON_NurbsCage::Reverse | ( | int | dir | ) |

## SetCV() [1/3]

bool ON_NurbsCage::SetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | const ON_3dPoint & | point
| ) |  |

## SetCV() [2/3]

bool ON_NurbsCage::SetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | const ON_4dPoint & | hpoint
| ) |  |

## SetCV() [3/3]

bool ON_NurbsCage::SetCV | ( | int | i,
|  | int | j,
|  | int | k,
|  | ON::point_style | ,
|  | const double * |
| ) |  |

## SetKnot()

bool ON_NurbsCage::SetKnot | ( | int | dir,
|  | int | knot_index,
|  | double | knot_value
| ) |  |

## SetWeight()

bool ON_NurbsCage::SetWeight | ( | int | i,
|  | int | j,
|  | int | k,
|  | double | w
| ) |  |

## SizeOf()

unsigned int ON_NurbsCage::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SpanCount()

int ON_NurbsCage::SpanCount | ( | int | dir | ) | const

## Transform()

ON_BOOL32 ON_NurbsCage::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Geometry.

## Transpose()

bool ON_NurbsCage::Transpose | ( | int | dir0,
|  | int | dir1
| ) |  |

## Trim()

bool ON_NurbsCage::Trim | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

## Weight()

double ON_NurbsCage::Weight | ( | int | i,
|  | int | j,
|  | int | k
| ) |  | const

## Write()

ON_BOOL32 ON_NurbsCage::Write | ( | ON_BinaryArchive & | archive | ) | const

virtual

Reimplemented from ON_Object.

## ZeroCVs()

bool ON_NurbsCage::ZeroCVs | ( |  | ) |

## Member Data Documentation

## m_cv

double* ON_NurbsCage::m_cv

Definition at line 1726 of file opennurbs_nurbssurface.h.

## m_cv_capacity

int ON_NurbsCage::m_cv_capacity

Definition at line 1725 of file opennurbs_nurbssurface.h.

## m_cv_count

int ON_NurbsCage::m_cv_count[3]

Definition at line 1721 of file opennurbs_nurbssurface.h.

## m_cv_stride

int ON_NurbsCage::m_cv_stride[3]

Definition at line 1724 of file opennurbs_nurbssurface.h.

## m_dim

int ON_NurbsCage::m_dim

Definition at line 1718 of file opennurbs_nurbssurface.h.

## m_is_rat

bool ON_NurbsCage::m_is_rat

Definition at line 1719 of file opennurbs_nurbssurface.h.

## m_knot

double* ON_NurbsCage::m_knot[3]

Definition at line 1723 of file opennurbs_nurbssurface.h.

## m_knot_capacity

int ON_NurbsCage::m_knot_capacity[3]

Definition at line 1722 of file opennurbs_nurbssurface.h.

## m_order

int ON_NurbsCage::m_order[3]

Definition at line 1720 of file opennurbs_nurbssurface.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h